Package net.sf.saxon.query

## Class QueryLibrary

- java.lang.Object
- - net.sf.saxon.query.QueryModule
  - - net.sf.saxon.query.QueryLibrary

- All Implemented Interfaces:
    `StaticContext`
  Direct Known Subclasses:
    `QueryLibraryImpl`

      public abstract class QueryLibrary
      extends QueryModule

  A QueryLibrary represents an independently compiled set of query modules that does not include a main module. Such a library can be compiled once, and then linked to different main modules without recompilation. The library contains one top-level module (itself a library module) together with the tree of modules that it imports; it is identified by the module URI of the top-level module.

  This is an abstract class; the concrete implementation is in Saxon-EE.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `QueryLibrary​(StaticQueryContext sqc)` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `abstract void` | `link​(QueryModule importer)` | Link this library module to a module that imports it

    - ### Methods inherited from class net.sf.saxon.query.QueryModule

      `addImportedNamespace, addImportedSchema, bindUnboundFunctionCalls, bindUnboundVariables, bindVariable, checkForCircularities, checkURIForPrefix, declareActiveNamespace, declareFunction, declarePrologNamespace, declareVariable, explainGlobalFunctions, fixupGlobalFunctions, fixupGlobalVariables, getBuiltInFunctionSet, getCodeInjector, getConfiguration, getConstructionMode, getContainingLocation, getDecimalFormatManager, getDefaultCollationName, getDefaultElementNamespace, getDefaultFunctionNamespace, getExecutable, getFunctionLibrary, getGlobalFunctionLibrary, getGlobalStackFrameMap, getGlobalVariables, getImportedFunctionLibrary, getImportedSchemaNamespaces, getKeyManager, getLiveNamespaceResolver, getLocalFunctionLibrary, getLocationURI, getModuleNamespace, getModuleVariables, getNamespaceResolver, getOptimizerOptions, getPackageData, getRequiredContextItemType, getRevalidationMode, getStaticBaseURI, getSystemId, getTopLevelModule, getUserDefinedFunction, getUserQueryContext, getXPathVersion, importsNamespace, isEmptyLeast, isImportedSchema, isInBackwardsCompatibleMode, isInheritNamespaces, isMainModule, isPreserveBoundarySpace, isPreserveNamespaces, isSchemaAware, issueWarning, isTopLevelModule, isUpdating, lookForModuleCycles, makeEarlyEvaluationContext, makeQueryModule, makeRetainedStaticContext, mayImportModule, optimizeGlobalFunctions, reportStaticError, reportStaticError, resolveTypeAlias, setBaseURI, setConstructionMode, setDefaultCollationName, setDefaultElementNamespace, setDefaultFunctionNamespace, setEmptyLeast, setExecutable, setInheritNamespaces, setIsMainModule, setLocationURI, setModuleNamespace, setPackageData, setPreserveBoundarySpace, setPreserveNamespaces, setRevalidationMode, typeCheckGlobalVariables, undeclareNamespace`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.expr.StaticContext

      `getUnprefixedElementMatchingPolicy`

- - ### Constructor Detail

    - #### QueryLibrary

          public QueryLibrary​(StaticQueryContext sqc)
                       throws XPathException

      Throws:
        `XPathException`

  - ### Method Detail

    - #### link

          public abstract void link​(QueryModule importer)
                             throws XPathException

      Link this library module to a module that imports it
      Parameters:
        `importer` - the importing module (a user of the library)
      Throws:
        `XPathException`